; "SG24064.inc" ,       
;                T6963C  TOSHIBA
; : Fahivec
;  20180130
;==================== LCD Define for Graphic-LCD SG24064a ===================
; LCD Data Port
			.equ	DATA_PORT	= PORTA	
			.equ	DATA_PIN	= PINA
			.equ	DATA_DDR	= DDRA
; LCD Control Ports							 04.01.2018 @Fahivec
			.equ	WR		= PD6	;/WR
			.equ	WR_PORT	= PORTD
			.equ	WR_DDR	= DDRD

			.equ	RD		= PD7	;/RD
			.equ	RD_PORT	= PORTD
			.equ	RD_DDR	= DDRD

			.equ	CD		= PC7	;C/D 	   A15  
			.equ	CD_PORT	= PORTC
			.equ	CD_DDR	= DDRC

			.equ	E		= PC5	;/CE 	   A13  
			.equ	E_PORT	= PORTC
			.equ	E_DDR	= DDRC

	.def	DATA_L	=	R20		;   !
	.def	DATA_H	=	R21
	.def	COMM	=	R22

.equ	VIDEORAM= 8192				;      
.equ	T_Home	= 0x0000			;     
.equ	T_Area	= 30				; for Font 8*8
.equ	T_Lines	= 8					; -  
.equ	T_End	= T_Home + T_Lines*T_Area	; +240 (-1!)

.equ	G_Home	= 0x0400			;     
.equ	G_Area	= 30				; for Font 8*8
.equ	G_Lines	= 64				; -  
.equ	G_End	= G_Home + G_Lines*G_Area; +1920 (-1!)

.equ	CG_Home	= 0x1800	;     
.equ	Offset	= 3			;     

.equ	DMODE	=	0x90	;  Display Mode
.equ	BLINK	=	1		;  ( 0)   
.equ	CURON	=	2		;  ( 1)  
.equ	TXTON	=	4		;  ( 2)   
.equ	GRAON	=	8		;  ( 3)   

;===========================================  ========================

.macro	T6963_COMMAND
						sbi	CD_PORT, CD		;    (1)
.endm
;-----------
.macro	T6963_DATA
						cbi	CD_PORT, CD		;    (0)
.endm
;-----------
.macro	T6963_ENABLE
						cbi	E_PORT, E		;   (/CE=0)
.endm
;-----------
.macro	T6963_DISABLE
						sbi	E_PORT, E		;   (/CE=1)
.endm
;-----------
.macro	PORT_IN
						out	DATA_DDR, NULL	; LCD Data Port  
.endm
;-----------
.macro	PORT_OUT
						outi  DATA_DDR, 255	; LCD Data Port  / Temp ! ***
.endm
;-----------
.macro	T6963_READ						;***   Temp ! ***
						PORT_IN				;    
						cbi	RD_PORT, RD		; READ
						T6963_ENABLE		;   (/CE=0)
						nop				;      8
						nop
						in @0, DATA_PIN		;     @0	!!!
						T6963_DISABLE
						sbi	RD_PORT, RD		; /READ
.endm
;-----------
.macro	T6963_WRITE						;***   Temp ! ***
						PORT_OUT			;    
						out DATA_PORT, @0	;      @0 !!
						cbi	WR_PORT, WR		; WRITE
						T6963_ENABLE		;   (/CE=0)
						nop			;      8
						nop
						T6963_DISABLE
						sbi	WR_PORT, WR		; /WRITE
.endm
;---------------------------------------------------------------------------
; STATUS Word Format:
;---------------------------------------------------------------
; STA7  | STA6  | STA5 | STA4 |  STA3  |  STA2  | STA1  | STA0
; BLINK | ERROR | CLR  |  -   | DAWRDY | DARRDY | BUSY2 | BUSY1
;---------------------------------------------------------------
.equ STA0=0;                                            \ accept instruction
.equ STA1=1;                                    \ accept data read/write
.equ STA2=2;                           \ Data Auto Read Ready flag
.equ STA3=3;                  \ Data Auto Write Ready flag
.equ STA5=5;    \ Clear flag indicating operation of the T6963C
.equ STA6=6
;       \ Error flag for Screen Peeking and Screen Copy commands
.equ STA7=7
;\ Blink flag to indicate status of Blink condition

.macro	T6963_STA10		;====================   STA0  STA1
					T6963_COMMAND				;				  BUSY1+BUSY2
		_STA10:		T6963_READ	Temp			;   Temp
					andi Temp, 1<<STA1 | 1<<STA0;   
					cpi	Temp, 1<<STA1 | 1<<STA0	;    , 
					brne _STA10
.endm
;-----------
.macro	T6963_STA2		;====================   STA2
					T6963_COMMAND				;				DARRDY
		_STA2:		T6963_READ	Temp			;   Temp
					andi Temp,  1<<STA2 		;  
					breq _STA2					;   , 
.endm
;-----------
.macro	T6963_STA3		;====================   STA3
					T6963_COMMAND				;				DAWRDY
		_STA3:		T6963_READ	Temp			;   Temp
					andi Temp, 1<<STA3 			;  
					breq _STA3					;   , 
.endm
;-----------
.macro	T6963_STA5		;====================   STA5
					T6963_COMMAND	;Clear flag indicating operation of the T6963C
		_STA5:		T6963_READ	Temp			;   Temp
					andi Temp, 1<<STA5 			;  
					breq _STA5					;   , 
.endm
;-----------
.macro	T6963_STA6		;====================   STA6
					T6963_COMMAND	;Error flag for Screen Peeking and Screen Copy
		_STA6:		T6963_READ	Temp			;   Temp
					andi Temp, 1<<STA6 			;  
					breq _STA6					;   , 
.endm
;-----------
.macro	T6963_STA7		;====================    STA7
					T6963_COMMAND	;Blink flag to indicate status of Blink condition
					T6963_READ	Temp			;   Temp
					andi Temp, 1<<STA7	; =  Z  7-   Temp
.endm
;---------------------------------------------------------------
.macro	CURSOR_POS		;====================     X/Y
						; :  CURSOR_POS POSX, POSY
			ldi	DATA_L,	@0		; POS X	= 
			ldi DATA_H,	@1		; POS Y =  
			ldi	COMM,	0x21	; Set Cursor Pointer
			rcall	LCD_WR2
.endm
;---------------------------------------------------------------
.macro	GRA_PTR		;==    VRAM  .  X/Y
						; :  GRA_PTR POSX, POSY
						; POS X	=  ()
						; POS Y =   ()
		.set GADDR = G_Home	+ @0 + @1 * G_Area
			ldi	DATA_L,	low (GADDR)
			ldi DATA_H,	high(GADDR)
			ldi	COMM,	0x24	; Set Address Pointer
			rcall	LCD_WR2
.endm
;---------------------------------------------------------------
.macro	TXT_PTR		;==    VRAM  .  X/Y
						; :  TXT_PTR POSX, POSY
						; POS X	= 
						; POS Y =  
		.set TADDR = T_Home	+ @0 + @1 * T_Area
			ldi	DATA_L,	low (TADDR)
			ldi DATA_H,	high(TADDR)
			ldi	COMM,	0x24	; Set Address Pointer
			rcall	LCD_WR2
.endm
;---------------------------------------------------------------
.macro	ADDR_PTR		;==     VRAM
						; :  ADDR_PTR 0x0400
			ldi	DATA_L,	low (@0)
			ldi DATA_H,	high(@0)
			ldi	COMM,	0x24	; Set Address Pointer
			rcall	LCD_WR2
.endm
;---------------------------------------------------------------
.macro	GRA_BIT		;== /     VRAM
					; :  GRA_BIT 1(0), BIT-No	(GRA_BIT 1, 5)
			ldi	COMM, 0xF0 | (@0<<3) | @1
			rcall	LCD_WR0
.endm
;---------------------------------------------------------------

; ************************************  ****************************

; ================================================   

LCD_PORT_SET:
	/*		sbi	E_PORT, E		;  = ."1"
			sbi WR_PORT, WR
			sbi RD_PORT, RD
			sbi CD_PORT, CD

			sbi	E_DDR, E		;  = 
			sbi WR_DDR, WR
			sbi RD_DDR, RD
			sbi CD_DDR, CD
	*/
	;      
			outi E_PORT, 1<<E | 1<<CD
			out  E_DDR , Temp
			outi WR_PORT, 1<<WR | 1<<RD; | 1<<RES
			out  WR_DDR , Temp
		RET

; #####################################################  

T6963_INIT:

			RCALL	CLR_VRAM	;==    
	; Graphic Home Address Set
			ldi DATA_L, low (G_Home)		; Addr. low 
			ldi DATA_H, high(G_Home)		; Addr. high
			ldi COMM, 0x42			; Set Graphic Home Address
			RCALL LCD_WR2

	; Graphic Area Set
			ldi DATA_L, low (G_Area)		; low =30	by Font 8*8
			ldi DATA_H, high(G_Area)		; high
			ldi COMM, 0x43			; Set Graphic Area
			RCALL LCD_WR2

	; Text Home Address Set
			ldi DATA_L, low (T_Home)		; Addr. low 
			ldi DATA_H, high(T_Home)		; Addr. high
			ldi COMM, 0x40		; Set Text Home Address
			RCALL LCD_WR2

	; Text Area Set
			ldi DATA_L, low (T_Area)		; low =30	by Font 8*8
			ldi DATA_H, high(T_Area)		; high
			ldi COMM, 0x41		; Set Text Area
			RCALL LCD_WR2

	; Address Pointer Set
			RCALL	TXT_HOME			;    .

	; Mode Set	/	  
			ldi COMM, 0x81		; XOR mode/Internal CG ROM
			RCALL LCD_WR0

	; DISPLAY MODE Set
			ldi COMM,	DMODE + TXTON + GRAON
			RCALL LCD_WR0
		RET
; ###########################################################################

LCD_WR1:	;    8    . DATA_L,   . COMM

				T6963_STA10			;   STA1:0
				T6963_DATA			;    (0)
				T6963_WRITE	DATA_L	;   (L)  
				RJMP	LCD_COMM

LCD_WR2:	;  16    . DATA_H:DATA_L,   . COMM

				T6963_STA10			;   STA1:0
				T6963_DATA			;    (0)
				T6963_WRITE	DATA_L	;   (L)  

				T6963_STA10			;   STA1:0
				T6963_DATA			;    (0)
				T6963_WRITE	DATA_H	;   (H)  

LCD_WR0:	;      . COMM
	LCD_COMM:	T6963_STA10			;   STA1:0
				T6963_WRITE	COMM	;    
		RET
;-----------------------------------------------

TXT_HOME:	;==       .
			TXT_PTR	0, 0
			RET
;---------------------------------------------------------------

CLR_VRAM:	;==    
			clr DATA_L
			clr DATA_H
			ldi	YL,	low (VIDEORAM)
			ldi	YH,	high(VIDEORAM)
			clr R0
			rjmp	LCD_FLUSH
;---------------------------------------------------------------

LCD_GRA0:	;    LCD

			ldi	DATA_L,	low (G_Home)
			ldi	DATA_H,	high(G_Home)
			ldi	YL,	low (G_Lines*G_Area)	; 64  
			ldi	YH,	high(G_Lines*G_Area)
			clr	R0					;   
			rjmp	LCD_FLUSH
;-----------------------------------------------

LCD_TXT0:	;    LCD

			ldi	DATA_L,	low (T_Home)
			ldi	DATA_H,	high(T_Home)
			ldi	YL,	(T_Lines*T_Area)		; 8  
			clr	YH
			clr	R0					;  
;-----------------------------------------------

LCD_FLUSH:	;     
			; R0		=  
			; DATA_H:L	=     
			; Y	(R29:28)=   

			ldi	COMM, 0x24	; Address Pointer Set
			RCALL	LCD_WR2
			ldi	COMM, 0xB0	; Data Auto Write Set
			RCALL	LCD_WR0
			T6963_STA10		;   STA0  STA1
LCD_FL_:
			T6963_STA3			;    STA3
			T6963_DATA			;   
			T6963_WRITE	R0		;    
			sbiw	Y,	1		;   
			brpl	LCD_FL_		;    

			ldi	COMM, 0xB2		; Auto Mode Reset
			RCALL	LCD_WR0
		RET
;-----------------------------------------------

ARRAY2LCD:	;     
			; Z	(R31:30)=         2!
			; DATA_H:L	=     
			; Y	(R29:28)= -  

			ldi	COMM, 0x24	; Address Pointer Set
			RCALL	LCD_WR2
			ldi	COMM, 0xB0	; Data Auto Write Set
			RCALL	LCD_WR0
			T6963_STA10		;   STA0  STA1
A2LCD_:
			lpm					;     Flash
			T6963_STA3			;    STA3
			T6963_DATA			;   
			T6963_WRITE	R0		;    
			adiw	Z,	1		;    
			sbiw	Y,	1		;   
			brne	A2LCD_		;    

			ldi	COMM, 0xB2		; Auto Mode Reset
			RCALL	LCD_WR0
		RET
;=========================================================================

TEXT2LCD:	;   ASCII     
			;     !!
			; Z	(R31:30)=  ()   Flash    2!
			;    = 0

			ldi	COMM, 0xB0	; Data Auto Write Set
			RCALL	LCD_WR0
			T6963_STA10		;   STA0  STA1
	T2LCD_:
			lpm					;     Flash
			tst		R0
			breq	T2LCD_E		;   

			ldi Temp, 0x20		;   
			sub	R0,	Temp		;       
								;  !

			T6963_STA3			;    STA3
			T6963_DATA			;   
			T6963_WRITE	R0		;    
			adiw	Z,	1		;    
			rjmp	T2LCD_		;    

	T2LCD_E:	ldi	COMM, 0xB2		; Auto Mode Reset
				RCALL	LCD_WR0
RET

;-----------------------------------------------

CGLOAD:			;     

			ldi	ZH, high(KOI8R_8X8 *2)	;    Flash
			ldi ZL, low (KOI8R_8X8 *2)
			ldi YH,	high (2048)			; - 
			ldi YL, low  (2048)
			ldi DATA_H, high(CG_Home)	;     
			ldi DATA_L, low (CG_Home)
			RCALL ARRAY2LCD

			ldi	DATA_L,	Offset		;    
			ldi	DATA_H,	0
			ldi	COMM,	0x22	; Set Offset Register
			RCALL	LCD_WR2

			ldi COMM, 0x89		; XOR mode/External CG ROM
			RCALL LCD_WR0
		RET

.include "FR08x08.inc"	;	 88   KOI-8R

;#########################################################################
/**/
